#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// The ChartControl sample form.
	/// </summary>
	public class FormMain : Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        DateTime start = new DateTime(2003, 11, 1);

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            InitializeControlSettings();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.chartControl1.Legend});
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Location = new System.Drawing.Point(466, 187);
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = ChartOrientation.Horizontal;
			this.chartControl1.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.Size = new System.Drawing.Size(552, 374);
			this.chartControl1.TabIndex = 2;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.ZoomOutIncrement = 1.5;
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chartControl1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "FormMain";
			this.Text = "Essential Chart - Chart Date Handling Sample";
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeControlSettings()
	    {
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

		    // Specify a ChartPalette:
		    Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
		    this.chartControl1.Palette = ChartColorPalette.Custom ;
		    this.chartControl1.Model.ColorModel.CustomColors = color;
		    this.chartControl1.Palette = ChartColorPalette.Custom ;

		    //this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
		    this.chartControl1.LegendPosition = ChartDock.Top;
		    this.chartControl1.HidePartialLabels = true;
	    }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		
		private void FormMain_Load(object sender, System.EventArgs e)
		{
			

			InitializeChartData();
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			this.chartControl1.Indexed = false;
			this.chartControl1.LegendPosition = ChartDock.Top;
			
			// fill the series with random date data
			Random random = new Random();
			
			DateTime rand = DateTime.Now;
			DateTimeFormatInfo dtInfo = new DateTimeFormatInfo();
			
            ChartSeries series1 = this.chartControl1.Model.NewSeries(" Server 1",ChartSeriesType.Column);
            series1.Text = series1.Name;

            series1.Points.Add(start.AddDays(7), 363);
            series1.Points.Add(start.AddDays(14), 417);
            series1.Points.Add(start.AddDays(21), 263);
            series1.Points.Add(start.AddDays(28), 453);
            series1.Points.Add(start.AddDays(35), 378);

			ChartSeries series2 = this.chartControl1.Model.NewSeries(" Server 2",ChartSeriesType.Column);
			series2.Text = series2.Name;

			series2.Points.Add(start.AddDays(7), 285);
			series2.Points.Add(start.AddDays(14), 254);
			series2.Points.Add(start.AddDays(21), 384);
			series2.Points.Add(start.AddDays(28), 427);
			series2.Points.Add(start.AddDays(35), 352);

            this.chartControl1.Series.Add(series1);
			this.chartControl1.Series.Add(series2);

			this.chartControl1.Series[0].Style.Border.Color = Color.FromArgb(100, Color.BlueViolet);
			this.chartControl1.Series[0].Style.Border.DashStyle = DashStyle.Solid;
			
			this.chartControl1.ChartArea.AxisSpacing = new SizeF(20,20);

			this.chartControl1.PrimaryXAxis.IntervalType = ChartDateTimeIntervalType.Days;
			this.chartControl1.PrimaryXAxis.LabelIntersectAction = ChartLabelIntersectAction.Rotate;
            this.chartControl1.PrimaryXAxis.LabelAligment = StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.ValueType = ChartValueType.DateTime;
			this.chartControl1.PrimaryXAxis.RangeType=ChartAxisRangeType.Set;
			this.chartControl1.PrimaryXAxis.DateTimeRange=new ChartDateTimeRange(start,start.AddDays(37),3,ChartDateTimeIntervalType.Days);

			this.chartControl1.PrimaryXAxis.DateTimeFormat = "d MMM, ddddd";
			this.chartControl1.Text="Network Load";
			this.chartControl1.PrimaryYAxis.Title="Server Load (MBytes)";


            // Using this we can set small ticks in between large ticks
            this.chartControl1.PrimaryXAxis.SmallTicksPerInterval = 7;
            this.chartControl1.PrimaryXAxis.SmallTickSize = new Size(2, 4);
            this.chartControl1.PrimaryXAxis.TickSize = new Size(4, 8);
            this.chartControl1.PrimaryXAxis.TickColor = Color.DarkGreen;
            this.chartControl1.ZoomFactorX = 0.00;
            this.chartControl1.VisibleRangeChanged += new EventHandler(chartControl1_VisibleRangeChanged);
		}

        void chartControl1_VisibleRangeChanged(object sender, EventArgs e)
        {
            TimeSpan tSpan = start.AddDays(37) - start;
            this.chartControl1.PrimaryXAxis.ZoomFactor = 1 / tSpan.TotalDays;            
        }
	}
}
